import { Component } from '@angular/core';
import { Platform } from 'ionic-angular';
import { StatusBar } from '@ionic-native/status-bar';
import { SplashScreen } from '@ionic-native/splash-screen';

import { TranslateService } from '@ngx-translate/core';
import { AuthService } from '../providers/auth-service/auth-service';

@Component({
  templateUrl: 'app.html'
})
export class MyApp {
  rootPage:any;

  constructor(
    platform: Platform, 
    statusBar: StatusBar, 
    splashScreen: SplashScreen,
    private translate: TranslateService,
    private auth: AuthService
  ) {
    platform.ready().then(() => {
      // Okay, so the platform is ready and our plugins are available.
      // Here you can do any higher level native things you might need.
      if (platform.is('android')) {
        statusBar.styleLightContent();
      } else {
        statusBar.styleDefault();
      }
      
      splashScreen.hide();

      this.initTranslate();

      this.rootPage = 'TabsPage';
    });

  
  }

  initTranslate() {
      // Set the default language for translation strings, and the current language.
      this.translate.setDefaultLang('ca');

      if (this.translate.getBrowserLang() !== undefined) {
          this.translate.use(this.translate.getBrowserLang());
      } else {
          this.translate.use('ca'); // Set your language here
      }

  }
}
