import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Place } from '../../models/place/place';
import { RegPlace } from '../../providers/utils/constants';

/**
 * Generated class for the CardItemPlaceComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
@Component({
  selector: 'card-item-place',
  templateUrl: 'card-item-place.html'
})
export class CardItemPlaceComponent {

  @Input('item') item: any; 
  @Output('onSelected') onSelected: EventEmitter<any> = new EventEmitter<any>();

  text: string;

  constructor() {
    console.log('Hello CardItemPlaceComponent Component');
    this.text = 'Hello World';
  }

  goToDetail(selected) {
    this.onSelected.emit({item: selected});
  }

  getImage() {
    if( this.item.imagesUrl ) {
      return this.item.imagesUrl[0];
    } else if (this.item.imageUrl) {
      return this.item.imageUrl;
    } else {
      return null;
    }
  }

  getRating() {
    if( this.item.ratings ) {
      return this.item.getRating();
    } else if ( this.item.rating ) {
      return this.item.rating;
    }
  }

}
