import { Component, Input, OnInit, Output, EventEmitter } from '@angular/core';

/**
 * Generated class for the StarsRatingComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
@Component({
  selector: 'stars-rating',
  templateUrl: 'stars-rating.html'
})
export class StarsRatingComponent implements OnInit {
  @Input('rate') rate: number;
  @Input('options') _options: any;

  @Output('onChange') onChange: EventEmitter<any> = new EventEmitter<any>();

  options = {
    readonly: 'false',
    max: '5'
  }

  constructor() {
    console.log('Hello StarsRatingComponent Component');
    
  }

  ngOnInit() {
    this.options = {
      readonly: this._options && this._options.readonly ? this._options.readonly : this.options.readonly,
      max: this._options && this._options.max ? this._options.max : this.options.max
    }
  }

  onModelChange(val) {
    this.onChange.emit({rate: val});
  }

}
