import { CheckInPlace } from "../../providers/utils/constants";


export interface UserInterface {
    display_name: string;
    email: string;
    photo_profile: string;
    uid: string;
    rating: number;
}

export class User {
   private _display_name: string;
   private _email: string;
   private _photo_profile: string;
   private _uid: string;
   private _rating: number;
   private _checkins: CheckInPlace[];


   set(data) {
       if(data) {
            this.display_name = data.display_name;
            this.email = data.email;
            this.photo_profile = data.photo_profile;
            this.uid = data.uid;
            this.rating = data.rating;
            this.checkins = data.checkins;
       }
   }



    /**
     * Getter displayName
     * @return {string}
     */
	public get display_name(): string {
		return this._display_name;
	}

    /**
     * Getter email
     * @return {string}
     */
	public get email(): string {
		return this._email;
	}

    /**
     * Getter photo_profile
     * @return {string}
     */
	public get photo_profile(): string {
		return this._photo_profile;
	}

    /**
     * Getter uid
     * @return {string}
     */
	public get uid(): string {
		return this._uid;
	}

    /**
     * Setter displayName
     * @param {string} value
     */
	public set display_name(value: string) {
		this._display_name = value;
	}

    /**
     * Setter email
     * @param {string} value
     */
	public set email(value: string) {
		this._email = value;
	}

    /**
     * Setter photo_profile
     * @param {string} value
     */
	public set photo_profile(value: string) {
		this._photo_profile = value;
	}

    /**
     * Setter uid
     * @param {string} value
     */
	public set uid(value: string) {
		this._uid = value;
	}
   


    /**
     * Getter rating
     * @return {number}
     */
	public get rating(): number {
		return this._rating;
	}

    /**
     * Setter rating
     * @param {number} value
     */
	public set rating(value: number) {
		this._rating = value;
    }



    /**
     * Getter checkins
     * @return {CheckInPlace[]}
     */
	public get checkins(): CheckInPlace[] {
		return this._checkins;
	}

    /**
     * Setter checkins
     * @param {CheckInPlace[]} value
     */
	public set checkins(value: CheckInPlace[]) {
		this._checkins = value;
	}
    
    


    public getPhotoProfile(): string {
		return this._photo_profile ? this._photo_profile : 'assets/imgs/no_photo_profile.png';
	}
    
}