import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams, ViewController } from 'ionic-angular';
import { AuthService } from '../../providers/auth-service/auth-service';
import { ViewContainerData } from '@angular/core/src/view';

/**
 * Generated class for the PopoverProfileSettingsPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@IonicPage()
@Component({
  selector: 'page-popover-profile-settings',
  templateUrl: 'popover-profile-settings.html',
})
export class PopoverProfileSettingsPage {

  constructor(
    public navCtrl: NavController, 
    public navParams: NavParams,
    public auth: AuthService,
    public viewCtrl: ViewController
  ) {
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad PopoverProfileSettingsPage');
  }

  dismiss() {
    this.viewCtrl.dismiss();
  }


  logOut() {
    this.dismiss();

    if (this.auth.authenticated) {
      this.auth.signOut();
    }

  }
}
