import { Component } from '@angular/core';
import { NavController, App, IonicPage, ModalController, PopoverController } from 'ionic-angular';
import { AuthService } from '../../providers/auth-service/auth-service';
import { User } from '../../models/user/user';
import { Observable } from 'rxjs/observable';
import { Subscription } from 'rxjs/Subscription';

@IonicPage()
@Component({
  selector: 'page-profile',
  templateUrl: 'profile.html'
})
export class ProfilePage {

  currentUser: User;

  private userSubscription: Subscription;

  public tab: string

  constructor(
    public navCtrl: NavController,
    public auth: AuthService,
    public app: App,
    public modalCtrl: ModalController,
    public popoverCtrl: PopoverController
  ) {

    this.tab = '2';

    this.userSubscription = this.auth.subscribeUser().subscribe( (user) => {
      if (user) {
        this.currentUser = new User();
        this.currentUser.set(user);
      } else {
        this.currentUser = null;
      }
    })
  }


  goToDetail($event) {
    let item = $event.item;
    this.navCtrl.push('DetailPlacePage', {item: item});
  }



  goToLogin() {
    this.getLogin().subscribe();
  }


  getLogin(): Observable<any> {
    return new Observable( (observer) => {
        const modal = this.modalCtrl.create('LoginPage');
        modal.onDidDismiss( (data) => {
            if ( data ) {
              observer.next(data);
            }
            observer.complete();
        })
        modal.present();
    })
  }


  presentPopover(myEvent) {
    let popover = this.popoverCtrl.create('PopoverProfileSettingsPage');
    popover.present({
      ev: myEvent
    });
  }

  ionViewWillUnload() {
    this.userSubscription.unsubscribe();
  }
}
