import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams, ViewController } from 'ionic-angular';

/**
 * Generated class for the RatingPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@IonicPage()
@Component({
  selector: 'page-rating-place',
  templateUrl: 'rating.html',
})
export class RatingPlacePage {

  data: any = {};

  rating: number = 0;

  comment: string;

  constructor(
    public navCtrl: NavController, 
    public navParams: NavParams,
    public viewCtrl: ViewController
  ) {
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad RatingPlacePage');
  }


  onRatingChange(val) {
    this.rating = val.rate;
  }


  save() {

    this.data['rating'] = this.rating;

    if (this.comment) {
      this.data['comment'] = this.comment;
    }

    this.dismiss(this.data);
  }

  dismiss(data?) {
    console.log(data);
    this.viewCtrl.dismiss(data);
  }
}
