import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { AlertController } from 'ionic-angular';
import { TranslateService } from '@ngx-translate/core';

/*
  Generated class for the AlertServiceProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
@Injectable()
export class AlertService {

  BUTTONS: any

  constructor(
    private alertCtrl: AlertController, 
    private translate: TranslateService
  ) {
   
    this.BUTTONS = {
      OK: '',
      CANCEL: ''
    };

    this.translate.get('ALERTS').subscribe( (value) => {
      console.log(value);
      this.BUTTONS.OK = value.BUTTONS.OK,
      this.BUTTONS.CANCEL = value.BUTTONS.CANCEL
    });
  }

  showError(message: string) {
    let alert = this.alertCtrl.create({
      title: 'Error',
      message: message,
      buttons: [
        {
          text: this.BUTTONS.OK
        }
      ]
    });
    alert.present();
  }

}
