import { LatLng, Marker } from "@ionic-native/google-maps";
import { User } from "firebase/app";

export interface PlaceCategory {
    uid: string;
    lang_key: string;
}

export interface PlaceDetails {
    free: boolean;
    water: boolean;
    wc: boolean;
}

export interface Activity {
    uid: string;
    lang_key: string;
}


export interface PlaceRating {
    rating: number;
    user_id: string;
    created_at: Date;
}

export interface PlaceComment {
    comment: string;
    user: UserPlace;
    rating?: number;
    created_at: Date;
}

export interface PlaceInterface {
    uid: string;
    name: string;
    description: string;
    location: LatLng;
    place_category: PlaceCategory;
    place_details: PlaceDetails;
    activities: Activity[];
    ratings: PlaceRating[];
    comments: PlaceComment[];
    images: string[];
    marker: Marker;
    user: UserPlace;
    created_at: Date;
    imagesUrl?: string[];
    updated_at: Date;
    checkin_registers: EntryRegister[];
}

export interface UserPlace {
    uid: string;
    display_name: string;
    photo_profile: string;
    rating: number;
}


export interface EntryRegister {
    created_at: Date;
    user: UserPlace
}

export interface CheckInPlace {
    created_at: Date;
    place: RegPlace;
}

export interface RegPlace {
    uid: string;
    name: string;
    location: LatLng;
    image: string;
    imageUrl?: string;
    place_category: PlaceCategory;
    rating: number;
}

export interface Photo {
    url: string;
    type: string;
}